#pragma once

#include <Writer.h>
#include <Vec3.h>

class Chunk;
class Block;
class Entity;

class NetworkMessage
{
private:
	char* adress;
	char adressLength;
	Framework::Vec3<float> minPosition;
	Framework::Vec3<float> maxPosition;
	bool broadcast;
	char* message;
	bool msgDelete;
	int msgLength;
	bool useBackground;
	int affectedDimension;

public:
	NetworkMessage();
	~NetworkMessage();

	void adressChunck(Chunk* zChunk);
	void adressEntity(Entity* zEntity);
	void adressBlock(Block* zBlock);
	void openDialog(Framework::Text dialogName);
	void adressGui(Framework::Text elementId);
	void setMessage(char* msg, int length, bool deleteMsg);
	void setUseBackground();
	void sendToAll();

	bool isAreaAffected(Framework::Vec3<float> min, Framework::Vec3<float> max, int dimensionId) const;
	void writeTo(Framework::StreamWriter* zWriter) const;
	bool isBroadcast() const;
	bool isEmpty() const;
	bool isUseBackground() const;
};